using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.PostProcessing;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;

namespace Feel.common
{
    public class BreastPump : MVRScript
    {
        Transform _hole;
        Transform _last_bone1;
        Transform _bone_target;
        Transform _liquid;
        
        private JSONStorableStringChooser _person_list;
        private UIDynamicPopup _person_select_pop;
        private JSONStorableStringChooser _nipple_list;
        private UIDynamicPopup _nipple_select_pop;
        private JSONStorableStringChooser _obj_list;
        private UIDynamicPopup _obj_select_pop;

        protected JSONStorableFloat lockPosX;
        protected JSONStorableFloat lockPosY;
        protected JSONStorableFloat lockPosZ;
        protected JSONStorableFloat liquid_height;

        private Atom _target_person;
        private Rigidbody _target_nipple;

        private bool _is_init = false;
        private int _initLoops = 0;
        private readonly int _maxInitLoops = 1000;

        public override void Init()
        {
            try
            {
                if (containingAtom.type != "CustomUnityAsset")
                {
                    SuperController.LogError("BreastPump - Not a usable environment." + containingAtom.type);
                    return;
                }

                UIDynamicButton object_update_btn = CreateButton("Object Update", false);
                object_update_btn.button.onClick.AddListener(OnObjectUpdate);

                _person_list = new JSONStorableStringChooser("Person Choice", null, null, "", OnSelectPerson);

                _person_list.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_person_list);

                _person_select_pop = CreateScrollablePopup(_person_list, false);
                _person_select_pop.popupPanelHeight = 800f;
                _person_select_pop.popup.onOpenPopupHandlers += SyncPersonChoices;
                _person_select_pop.label = "Person:";

                _nipple_list = new JSONStorableStringChooser("Nipple Choice", null, null, "", OnSelectNipple);

                _nipple_list.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_nipple_list);

                _nipple_select_pop = CreateScrollablePopup(_nipple_list, false);
                _nipple_select_pop.popupPanelHeight = 300f;
                _nipple_select_pop.popup.onOpenPopupHandlers += SyncPersonChoices;
                _nipple_select_pop.label = "Nipple:";

                List<string> nipple_list = new List<string>();
                nipple_list.Add("rNipple");
                nipple_list.Add("lNipple");
                _nipple_list.choices = nipple_list;

                _obj_list = new JSONStorableStringChooser("Object Choice", null, null, "", OnSelectOjbect);

                _obj_list.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_obj_list);

                _obj_select_pop = CreateScrollablePopup(_obj_list, false);
                _obj_select_pop.popupPanelHeight = 300f;
                _obj_select_pop.popup.onOpenPopupHandlers += SyncPersonChoices;
                _obj_select_pop.label = "Object:";

                lockPosX = new JSONStorableFloat("lock x position", 0f, OnChangeData, -0.2f, 0.2f);
                RegisterFloat(lockPosX);
                CreateSlider(lockPosX, true);
                lockPosY = new JSONStorableFloat("lock y position", 0f, OnChangeData, -0.5f, 0.5f);
                RegisterFloat(lockPosY);
                CreateSlider(lockPosY, true);
                lockPosZ = new JSONStorableFloat("lock z position", 0f, OnChangeData, -0.2f, 0.2f);
                RegisterFloat(lockPosZ);
                CreateSlider(lockPosZ, true);
                liquid_height = new JSONStorableFloat("liquid height", 0f, OnLiquidHeight, 0f, 1f);
                RegisterFloat(liquid_height);
                CreateSlider(liquid_height, true);


                // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("About",
                    "<color=#000><size=35><b>Breast Pump</b></size></color>\n\n" +
                    "<color=#333>" +
                    "Control the pump.\n\n" +
                    "thank you for your support\n" +
                    "<b>https://www.patreon.com/feel_vam</b>\n\n" +
                    "</color>");
                UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 300.0f;

                var btn = CreateButton("Go To Support", true);
                btn.button.onClick.AddListener(() =>
                {
                    Application.OpenURL("https://www.patreon.com/feel_vam");
                });

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        private void OnObjectUpdate()
        {
            UpdateAtomData();
        }

        private void OnSelectPerson(string target)
        {
            _target_person = SuperController.singleton.GetAtomByUid(target);
        }

        private void OnSelectNipple(string target)
        {
            if (_target_person != null) _target_nipple = _target_person.rigidbodies.First(fc => fc.name == target);
        }

        private void OnSelectOjbect(string target)
        {
            if(SuperController.singleton.GetAtomByUid(target) != null && _last_bone1 != null)
            {
                Rigidbody bone1_rigidbody = _last_bone1.GetComponent<Rigidbody>();
                bone1_rigidbody.useGravity = false;
                bone1_rigidbody.isKinematic = true;
                _bone_target = SuperController.singleton.GetAtomByUid(target).mainController.transform;
            }
            
        }

        private void OnLiquidHeight(float value)
        {
            if (_liquid == null) return;
            Renderer renderer = _liquid.GetComponent<Renderer>();
            float n = 0.48f + (value / 20f);
            renderer.material.SetFloat("_FillAmount", n);
        }

        private void SyncPersonChoices()
        {
            
        }

        void OnChangeData(float value)
        {

        }

        private void UpdateAtomData()
        {
            List<string> atomChoices = new List<string>();
            List<string> objChoices = new List<string>();
            Atom atom;
            foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
            {
                atom = SuperController.singleton.GetAtomByUid(atomUID);
                JSONStorable geometry = atom.GetStorableByID("geometry");
                if (geometry != null)
                {
                    atomChoices.Add(atomUID);
                }
                objChoices.Add(atomUID);
            }

            _person_list.choices = atomChoices;
            _obj_list.choices = objChoices;
        }

        // Update is called with each rendered frame by Unity
        void Update()
        {
            if (_target_nipple && _hole)
            {
                _hole.transform.position = _target_nipple.transform.position;
                _hole.transform.rotation = _target_nipple.transform.rotation;
                _hole.transform.Rotate(new Vector3(90f, 0f, 0f));

                if (_bone_target)
                {
                    Vector3 offset1 = new Vector3(lockPosX.val, lockPosY.val, lockPosZ.val);
                    _last_bone1.position = _bone_target.position;
                    _last_bone1.Translate(offset1);
                    //_last_bone2.Translate(offset2);
                    _last_bone1.rotation = _bone_target.rotation;
                    //_last_bone2.rotation = _bone_target.rotation;
                    
                }
            }

            if (_initLoops < _maxInitLoops)
            {
                _initLoops++;
                FirstInit();
            }
            else
            {
                if (_initLoops == 1001)
                {
                    SuperController.LogError("MilkBattle Load Failure " + _initLoops);
                    _initLoops += 1;
                }
            }
        }

        private void FirstInit()
        {
            bool isl = SuperController.singleton.isLoading;
            if (isl) return;

            _hole = getChildRoot(containingAtom.reParentObject.transform, "HoleParent");
            _liquid = getChildRoot(containingAtom.reParentObject.transform, "Liquid");
            _last_bone1 = getChildRoot(containingAtom.reParentObject.transform, "Bone.009");


            UpdateAtomData();
            OnSelectPerson(_person_list.val);
            OnSelectNipple(_nipple_list.val);
            OnSelectOjbect(_obj_list.val);
            _is_init = true;
            _initLoops += 1001;
        }

        void FixedUpdate()
        {
            
        }

        public static Transform getObjectRoot(Transform parent, string rootName)
        {
            foreach (Transform child in parent)
            {
                if (child.name.Contains(rootName))
                {
                    return child;
                }
                else
                {
                    Transform childSearch = getObjectRoot(child, rootName);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }

        public static Transform getChildRoot(Transform parent, string searchName)
        {
            foreach (Transform child in parent)
            {
                if (child.name == searchName)
                {

                    return child;
                }
                else
                {
                    Transform childSearch = getChildRoot(child, searchName);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }

    }
	
}